/********************************************
  PURPOSE: Cover and Uncover cat bowl
  Created by: Mark Nelson, inspired by sketches from Rudy Schlaf
  DATE: 4/7/2019
*********************************************/

/************* LIBRARIES ********************/
#include <Wire.h>      // Trpical Library
#include <StepperAK.h> // Stepper Motor lib.
#include <Servo.h>        //Arduino standard library

/************* STEPPER MOTOR ***************/
#define gearratio 64 //1:64 gear ratio // Stepper motor
const int stepsPerRevolution = 2048;   // One Revolution
Stepper myStepper(stepsPerRevolution, 9,10,11,12);

/*************** BUTTONS ** *****************/
#define downbutton 2
#define upbutton 3
/************** SERVO MOTOR ****************/
#define servopin 6       //this defines pin 5 as the pin used for the servo control lead (orange)
Servo myservo;            // instantiate a Servo object named 'myservo' 
        
/************************set-up function******************************************************************/                                         

void setup()
{
  Serial.begin(9600);

  myStepper.setSpeed(0.15*gearratio);  // Set gear ratio for motor
  
  myservo.attach(servopin);           // attaches the servo on pin 8 to the servo object 

  pinMode(upbutton, INPUT);           // Declares the button as an input
  digitalWrite(upbutton, HIGH);       
  pinMode(downbutton, INPUT);         // Declares the button as an input
  digitalWrite(downbutton, HIGH);

}

/*************************main loop************************************************************************/

void loop() {
  
  
        if (digitalRead(upbutton)==HIGH ){        // Cover bowl(Bottom Button)
       /*** Servo Motor ***/
              myservo.write(120);                   // Set Servo speed
              delay(120);                           // Allow set time to pass to get to desired position
              myservo.write(93);                    // Set Servo Speed to zero to stop motion
              delay(400);
       /*** Stepper Motor ***/
              myStepper.step(-5.5*stepsPerRevolution);
                  delay(120);                           // delay before next action occurs
            }
        if (digitalRead(downbutton)==HIGH ){           //Uncover Bowl (Top Botton)
        /*** Stepper Motor ***/
             myStepper.step(5.5*stepsPerRevolution);  // 
             delay(120);                             // delay before next action occurs
       /*** Servo Motor ***/
             myservo.write(80);                      // Set Servo speed
             delay(120);                             // Allow set time to pass to get to desired position
             myservo.write(93);                      // Set Servo Speed to zero to stop motion
             delay(200);    
        } 

    
  }



/************* TA-DA ********************/
